#!/usr/bin/python
# -*- coding: utf-8 -*-

#descriptivo.py Operación descriptivo

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
from qt import *
from rpy import *
from Driza.widgets import wopciones

def funcion(dato,variable,cosa,opciones):  # Cambiar cosa por caso
	diccionario={}
	lista=[float(x) for x in dato[variable]]
	if opciones.has_key("Media"):
		diccionario["media"]=r.mean(lista)
	if opciones.has_key("Varianza"):
		diccionario["varianza"]=r.var(lista)
	if opciones.has_key(u"Desviación"):
		diccionario["desviacion"]=r.sd(lista)
	if opciones.has_key("Mediana"):
		diccionario["mediana"]=r.median(lista)
	if opciones.has_key("Moda"):
		diccionario["moda"]="TODO"
	if opciones.has_key("Rango"):
		diccionario["rango"]=r.range(lista)
	if opciones.has_key(u"Máximo"):
		diccionario["maximo"]=r.max(lista)
	if opciones.has_key(u"Mínimo"):
		diccionario["minimo"]=r.min(lista)
	if opciones.has_key("Percentil"):
		diccionario["percentil"]="TODO"

	return diccionario

def initresultado(resultado,opciones):
	"""Inicializa al objeto resultado, añadiendole lo que crea conveniente"""
	resultado.addTablaSimple("resultado")
	resultado["resultado"].titulo="Descriptivo"
	lista=[]
	if opciones.has_key("Media"):
		lista.append("Media")
	if opciones.has_key("Varianza"):
		lista.append("Varianza")
	if opciones.has_key(u"Desviación"):
		lista.append(u"Desviación")
	if opciones.has_key("Mediana"):
		lista.append("Mediana")
	if opciones.has_key("Moda"):
		lista.append("Moda")
	if opciones.has_key("Rango"):
		lista.append("Rango")
	if opciones.has_key(u"Máximo"):
		lista.append(u"Máximo")
	if opciones.has_key(u"Mínimo"):
		lista.append(u"Mínimo")
	if opciones.has_key("Percentil"):
		lista.append("Percentil")

	resultado["resultado"].settitulo(lista)


def interfazresultado(resultado,listaopciones):
	"""Este método dice como introducir los datos en la tabla"""
	variable=listaopciones[0]
	caso=listaopciones[1]
	diccionario=listaopciones[2]
	lista=[]
	if diccionario.has_key("media"):
		lista.append(diccionario["media"])
	if diccionario.has_key("varianza"):
		lista.append(diccionario["varianza"])
	if diccionario.has_key("desviacion"):
		lista.append(diccionario["desviacion"])
	if diccionario.has_key("mediana"):
		lista.append(diccionario["mediana"])
	if diccionario.has_key("moda"):
		lista.append(diccionario["moda"])
	if diccionario.has_key("rango"):
		lista.append(diccionario["rango"])
	if diccionario.has_key("maximo"):
		lista.append(diccionario["maximo"])
	if diccionario.has_key("minimo"):
		lista.append(diccionario["minimo"])
	if diccionario.has_key("percentil"):
		lista.append(diccionario["percentil"])

	resultado["resultado"].set(variable,caso,lista)

diccionarioopciones={
		"nombre":"Opciones",
		"tipo":"SeleccionMultiple",
		"opciones":["Media","Varianza",u"Desviación","Mediana","Moda","Rango",u"Máximo",u"Mínimo"]}
percentil={"nombre":"Percentil","tipo":"EntradaTexto"}

widget={"tipo":"CalculoSimple","opciones":[diccionarioopciones,percentil]}



